# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::EdgeGateway::Mgmt::V2019_03_01
  module Models
    #
    # Represents the networkAdapter on a device.
    #
    class NetworkAdapter

      include MsRestAzure

      # @return [String] Instance ID of network adapter.
      attr_accessor :adapter_id

      # @return [NetworkAdapterPosition] Hardware position of network adapter.
      attr_accessor :adapter_position

      # @return [Integer] Logical index of the adapter.
      attr_accessor :index

      # @return [String] Node ID of the network adapter.
      attr_accessor :node_id

      # @return [String] Network adapter name.
      attr_accessor :network_adapter_name

      # @return [String] Hardware label for the adapter.
      attr_accessor :label

      # @return [String] MAC address.
      attr_accessor :mac_address

      # @return [Integer] Link speed.
      attr_accessor :link_speed

      # @return [NetworkAdapterStatus] Value indicating whether this adapter is
      # valid. Possible values include: 'Inactive', 'Active'
      attr_accessor :status

      # @return [NetworkAdapterRDMAStatus] Value indicating whether this
      # adapter is RDMA capable. Possible values include: 'Incapable',
      # 'Capable'
      attr_accessor :rdma_status

      # @return [NetworkAdapterDHCPStatus] Value indicating whether this
      # adapter has DHCP enabled. Possible values include: 'Disabled',
      # 'Enabled'
      attr_accessor :dhcp_status

      # @return [Ipv4Config] The IPv4 configuration of the network adapter.
      attr_accessor :ipv4configuration

      # @return [Ipv6Config] The IPv6 configuration of the network adapter.
      attr_accessor :ipv6configuration

      # @return [String] The IPv6 local address.
      attr_accessor :ipv6link_local_address

      # @return [Array<String>] The list of DNS Servers of the device.
      attr_accessor :dns_servers


      #
      # Mapper for NetworkAdapter class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'NetworkAdapter',
          type: {
            name: 'Composite',
            class_name: 'NetworkAdapter',
            model_properties: {
              adapter_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'adapterId',
                type: {
                  name: 'String'
                }
              },
              adapter_position: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'adapterPosition',
                type: {
                  name: 'Composite',
                  class_name: 'NetworkAdapterPosition'
                }
              },
              index: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'index',
                type: {
                  name: 'Number'
                }
              },
              node_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'nodeId',
                type: {
                  name: 'String'
                }
              },
              network_adapter_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'networkAdapterName',
                type: {
                  name: 'String'
                }
              },
              label: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'label',
                type: {
                  name: 'String'
                }
              },
              mac_address: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'macAddress',
                type: {
                  name: 'String'
                }
              },
              link_speed: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'linkSpeed',
                type: {
                  name: 'Number'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              rdma_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'rdmaStatus',
                type: {
                  name: 'String'
                }
              },
              dhcp_status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'dhcpStatus',
                type: {
                  name: 'String'
                }
              },
              ipv4configuration: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'ipv4Configuration',
                type: {
                  name: 'Composite',
                  class_name: 'Ipv4Config'
                }
              },
              ipv6configuration: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'ipv6Configuration',
                type: {
                  name: 'Composite',
                  class_name: 'Ipv6Config'
                }
              },
              ipv6link_local_address: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'ipv6LinkLocalAddress',
                type: {
                  name: 'String'
                }
              },
              dns_servers: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'dnsServers',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
